@ECHO OFF
REM #############################################################
REM                CodeTyphon Studio 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################

REM bbFPCType=%1
REM bbFPCCPUOS=%2
REM bbFPCStartEXE=%3
REM bbTARGETCPU=%4
REM bbTARGETOS=%5
REM bbFPCCrossEXE=%6
REM bbParam=%7

IF '%1'=='' GOTO GO_END
IF '%2'=='' GOTO GO_END
IF '%3'=='' GOTO GO_END
IF '%4'=='' GOTO GO_END
IF '%5'=='' GOTO GO_END
IF '%6'=='' GOTO GO_END
IF '%7'=='' GOTO GO_END

IF '%2'=='%4-%5' GOTO GO_ERROR

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ INIT @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

if '%1'=='win32' SET path=C:\codetyphon\fpc\fpc32\bin\i386-win32;%path%
if '%1'=='win64' SET path=C:\codetyphon\fpc\fpc64\bin\x86_64-win64;%path%

if '%1'=='win64' (
SET bbbits=64
SET bbbincross=win64-%4-%5
) ELSE (
SET bbbits=32
SET bbbincross=win32-%4-%5
)

if NOT '%7'=='xxxx' (
SET bbbincross=%bbbincross%--%7
)

REM @@@@@@@@@@@@@@@@@@@@@@@@@@ Print Settings @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ECHO.
ECHO -----------------------------------------------
ECHO    GNU Cross toolschains Engine settings
ECHO -----------------------------------------------
ECHO.
ECHO FPCType=%1
ECHO FPCCPUOS=%2
ECHO FPCStartEXE=%3
ECHO TARGETCPU=%4
ECHO TARGETOS=%5
ECHO FPCCrossEXE=%6
ECHO Param=%7
ECHO.

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ CrossEng @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
if NOT EXIST ..\..\CrossEng (
if EXIST ..\..\allzips\src\CrossEng.7z (
ECHO.
ECHO -------------------------------------------------------
ECHO              Extract CrossEng...
ECHO -------------------------------------------------------
ECHO.
..\..\binBase\%2\7zr.exe x ..\..\allzips\src\CrossEng.7z -o..\..\ -y

) ELSE (
ECHO [ERROR]: msys Zip File NOT EXIST ?????? 
EXIT
)
)

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ MinGW @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
ECHO.
ECHO [INFO]: Use MinGW%bbbits%
ECHO.

if EXIST ..\..\CrossEng\mingw%bbbits% (
del /f/s/q ..\..\CrossEng\mingw%bbbits%\ > nul
rmdir /s/q ..\..\CrossEng\mingw%bbbits%\
)

if EXIST ..\..\allzips\src\mingw%bbbits%.7z (
ECHO.
ECHO -------------------------------------------------------
ECHO              Extract MinGW%bbbits%...
ECHO -------------------------------------------------------
ECHO.
..\..\binBase\%2\7zr.exe x ..\..\allzips\src\mingw%bbbits%.7z -o..\..\CrossEng\ -y

) ELSE (
ECHO [ERROR]: MinGW%bbbits% Zip File NOT EXIST ?????? 
EXIT
)

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ binutils @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ECHO. 
ECHO ----------------------------------------------------------------
ECHO       Stage -3: Prepare binutils
ECHO ----------------------------------------------------------------
ECHO.

if EXIST ..\..\CrossEng\binutils (
del /f/s/q ..\..\CrossEng\binutils\ > nul
rmdir /s/q ..\..\CrossEng\binutils\
)

if EXIST ..\..\CrossEng\binutilstemp (
del /f/s/q ..\..\CrossEng\binutilstemp\ > nul
rmdir /s/q ..\..\CrossEng\binutilstemp\
)

if EXIST ..\..\allzips\src\binutils.7z (
ECHO.
ECHO -------------------------------------------------------
ECHO         Stage -2: Extract binutils...
ECHO -------------------------------------------------------
ECHO.

..\..\binBase\%2\7zr.exe x ..\..\allzips\src\binutils.7z -o..\..\CrossEng\ -y

) ELSE (
ECHO [ERROR]: binutils Zip File NOT EXIST ?????? 
exit
)

mkdir ..\..\CrossEng\binutilstemp

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
REM if the script find CUSTOM x_Cross_Binutils_xxxx.sh will execute this script..

IF EXIST x_Cross_Binutils_%4_%5_%7.sh (
START /D C:\codetyphon\CrossEng\ /B /WAIT C:\codetyphon\CrossEng\CrossEng%bbbits%.bat C:\codetyphon\ScriptsWin\Crossbuild\x_Cross_Binutils_%4_%5_%7.sh %1 %2 %3 %4 %5 %6
GOTO STRIPMOVE
)

IF EXIST x_Cross_Binutils_%4_%5.sh (
START /D C:\codetyphon\CrossEng\ /B /WAIT C:\codetyphon\CrossEng\CrossEng%bbbits%.bat C:\codetyphon\ScriptsWin\Crossbuild\x_Cross_Binutils_%4_%5.sh %1 %2 %3 %4 %5 %6
GOTO STRIPMOVE
)

IF EXIST x_Cross_Binutils_%5.sh (
START /D C:\codetyphon\CrossEng\ /B /WAIT C:\codetyphon\CrossEng\CrossEng%bbbits%.bat C:\codetyphon\ScriptsWin\Crossbuild\x_Cross_Binutils_%5.sh %1 %2 %3 %4 %5 %6
GOTO STRIPMOVE
)

START /D C:\codetyphon\CrossEng\ /B /WAIT C:\codetyphon\CrossEng\CrossEng%bbbits%.bat C:\codetyphon\ScriptsWin\Crossbuild\x_Cross_Binutils.sh %1 %2 %3 %4 %5 %6


REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
:STRIPMOVE
if EXIST ..\..\CrossEng\binutilstemp\bin (
ECHO.
ECHO -------------------------------------------------------
ECHO         Stage -1: Strip and move Toochains files...
ECHO -------------------------------------------------------
ECHO.

START /B /WAIT ..\..\fpc\fpc%bbbits%\bin\%2\Strip ..\..\CrossEng\binutilstemp\bin\*.exe
START /B /WAIT ..\..\fpc\fpc%bbbits%\bin\%2\upx ..\..\CrossEng\binutilstemp\bin\*.exe

mkdir C:\codetyphon\binToolchains\%bbbincross%

copy /Y ..\..\CrossEng\binutilstemp\bin\*.* ..\..\binToolchains\%bbbincross%\

ECHO.
ECHO [FINAL INFO]: Toolschains for %4-%5 Param:%7 Build OK...!!!
ECHO.

) ELSE (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO     [ERROR]: Sorry Toolschains for %4-%5 Param:%7 NOT Build. 
ECHO ???????????????????????????????????????????????????????????
ECHO.
)

GOTO GO_END

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

:GO_ERROR

ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO     [ERROR]:  Sorry NO Script Parameters. 
ECHO ???????????????????????????????????????????????????????????
ECHO.


:GO_END
EXIT





