@ECHO OFF
REM #############################################################
REM                CodeTyphon Studio 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################

REM ----------- Check for Bitness------------------
Set _BITNESS=64
IF %PROCESSOR_ARCHITECTURE% == x86 (
  IF NOT DEFINED PROCESSOR_ARCHITEW6432 Set _BITNESS=32
  )  
REM ----------------------------------------------- 

ECHO.
ECHO --------------------------------------------------
ECHO        Restore Typhon Default IDE Setings
ECHO --------------------------------------------------

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@ For Win32 @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

IF EXIST "%APPDATA%\typhon32" (
del /f/s/q "%APPDATA%\typhon32" > nul
rmdir /s/q "%APPDATA%\typhon32"
)

IF NOT EXIST "%APPDATA%\typhon32" (
mkdir "%APPDATA%\typhon32"
)
xcopy /E /R /Y ..\binSettings\settings\i386-win32-win32\styphon\*.* "%APPDATA%\typhon32\"

IF NOT EXIST "%APPDATA%\typhon32\userschemes" (
mkdir "%APPDATA%\typhon32\userschemes"
)
xcopy /E /R /Y ..\binSettings\settings\alluserschemes\*.* "%APPDATA%\typhon32\userschemes\"

ECHO [INFO]: Restore Typhon32 Settings finish
ECHO.
REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@ For Win64 @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


if %_Bitness% == 32 (
EXIT
)

IF EXIST "%APPDATA%\typhon64" (
del /f/s/q "%APPDATA%\typhon64" > nul
rmdir /s/q "%APPDATA%\typhon64"
)

IF NOT EXIST "%APPDATA%\typhon64" (
mkdir "%APPDATA%\typhon64"
)
xcopy /E /R /Y ..\binSettings\settings\x86_64-win64-win32\styphon\*.* "%APPDATA%\typhon64\"

IF NOT EXIST "%APPDATA%\typhon64\userschemes" (
mkdir "%APPDATA%\typhon64\userschemes"
)
xcopy /E /R /Y ..\binSettings\settings\alluserschemes\*.* "%APPDATA%\typhon64\userschemes\"

ECHO [INFO]: Restore Typhon64 Settings finish
ECHO.

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@

EXIT


