@ECHO OFF
REM #############################################################
REM                CodeTyphon Studio 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################

ECHO ----------------------------------------------
ECHO  Please wait... Removing  All FreePascal Parts
ECHO ----------------------------------------------

REM ------------- Remove FreePascal Bin Directory ------------------
IF EXIST ..\fpc (
del /f/s/q ..\fpc\ > nul
rmdir /s/q ..\fpc\
ECHO [INFO]: FreePascal Bin Directory Removed OK
) ELSE (
ECHO [INFO]: FreePascal Bin Directory NOT EXIST, nothing to do ...
)

REM ------------- Remove FreePascal Source Directory ---------------
IF EXIST ..\fpcsrc (
del /f/s/q ..\fpcsrc\ > nul
rmdir /s/q ..\fpcsrc\
ECHO [INFO]: FreePascal Source Directory Removed OK
) ELSE (
ECHO [INFO]: FreePascal Source Directory NOT EXIST, nothing to do ...
)

REM ------------- Remove GDB Directory ---------------
IF EXIST ..\binGDB (
del /f/s/q ..\binGDB\ > nul
rmdir /s/q ..\binGDB\
ECHO [INFO]: GDB Source Directory Removed OK
) ELSE (
ECHO [INFO]: GDB Source Directory NOT EXIST, nothing to do ...
)

REM ------------- Remove Toolchains Engine Directory -----------------------
IF EXIST ..\CrossEng (
del /f/s/q ..\CrossEng\ > nul
rmdir /s/q ..\CrossEng\
ECHO [INFO]: Toolchains Engine Directory Removed OK
) ELSE (
ECHO [INFO]: Toolchains Engine Directory NOT EXIST, nothing to do ...
)

REM #############################################################

START /B /WAIT xx_CodeTyphon_Remove_ChainsLibrary
START /B /WAIT xx_CodeTyphon_Remove_Libraries

REM #############################################################

ECHO.
ECHO [INFO]: All FreePascal parts removed from disk

EXIT





