@ECHO OFF
REM #############################################################
REM                CodeTyphon Studio 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################

REM Check for Bitness
Set _BITNESS=64
IF %PROCESSOR_ARCHITECTURE% == x86 (
  IF NOT DEFINED PROCESSOR_ARCHITEW6432 Set _BITNESS=32
  )

REM Check for user with Administrator privileges
NET SESSION >nul 2>&1
IF %ERRORLEVEL% EQU 0 (
Set _ADMIN=YES
) ELSE (
Set _ADMIN=NO
)

REM =====================================================
ECHO .
ECHO ===================================================
ECHO            CodeTyphon System Info
ECHO ===================================================
 
ver
ECHO .................................................
REM systeminfo
systeminfo | findstr /B /C:"OS" /C:"System" /C:"Total"
ECHO .................................................
ECHO Operating System is: %_BITNESS% bit
ECHO OS Folder: %WINDIR%
ECHO .
ECHO Computer name: %COMPUTERNAME%
ECHO .  
ECHO User Name: %USERNAME%
ECHO User with Administrator Privileges: %_ADMIN%
ECHO User Settings Folder: %APPDATA%
ECHO User Profile Folder: %USERPROFILE%
ECHO User Temp Folder: %TEMP%
ECHO .  
ECHO All Users Profile Folder: %ALLUSERSPROFILE%
ECHO All Users Programs Folder:%ProgramFiles%

ECHO .
ECHO ------- PATH ------
ECHO %PATH%
ECHO .

exit