@ECHO OFF
REM #############################################################
REM                CodeTyphon Studio 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################

REM ----------- Check for Bitness------------------
Set _BITNESS=64
IF %PROCESSOR_ARCHITECTURE% == x86 (
  IF NOT DEFINED PROCESSOR_ARCHITEW6432 Set _BITNESS=32
  )  
REM -----------------------------------------------


ECHO.
ECHO -------------------------------------------------------
ECHO        Extract Win32 Toolchains Library...
ECHO -------------------------------------------------------
ECHO.
if EXIST ..\allzips\cross\bincross-i386-win32.7z (
..\binBase\i386-win32\7zr.exe x ..\allzips\cross\bincross-common.7z -o..\ -y
..\binBase\i386-win32\7zr.exe x ..\allzips\cross\bincross-i386-win32.7z -o..\ -y
) ELSE (
ECHO [ERROR]: Win32 Toolchains Library Zip File NOT EXIST ???????? 
)

if %_Bitness% == 32 (
EXIT
)

ECHO.
ECHO -------------------------------------------------------
ECHO        Extract Win64 Toolchains Library...
ECHO -------------------------------------------------------
ECHO.
if EXIST ..\allzips\cross\bincross-x86_64-win64.7z (
..\binBase\x86_64-win64\7zr.exe x ..\allzips\cross\bincross-common.7z -o..\ -y
..\binBase\x86_64-win64\7zr.exe x ..\allzips\cross\bincross-x86_64-win64.7z -o..\ -y
) ELSE (
ECHO [ERROR]: Win64 Toolchains Library Zip File NOT EXIST ???????? 
)

EXIT
