@ECHO OFF
REM #############################################################
REM                CodeTyphon Studio 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################


REM ----------- Check for Bitness------------------
Set _BITNESS=64
IF %PROCESSOR_ARCHITECTURE% == x86 (
  IF NOT DEFINED PROCESSOR_ARCHITEW6432 Set _BITNESS=32
  )  
REM ----------------------------------------------- 
 
if %_Bitness% == 64 (
SET varzipdir="x86_64-win64"
) ELSE (
SET varzipdir="i386-win32"
)
REM ----------------------------------------------- 

ECHO.
ECHO -------------------------------------------------------
ECHO              Extract FreePascal Source... 
ECHO -------------------------------------------------------
if EXIST ..\allzips\src\fpc_src.7z (
..\binBase\%varzipdir%\7zr.exe x ..\allzips\src\fpc_src.7z -o..\ -y
) ELSE (
ECHO [ERROR]: FreePascal Source Zip File NOT EXIST ???????? 
)

REM #############################################################

START /B /WAIT x_FPC_Exract_ChainsLibrary_from_ZipFile
START /B /WAIT x_FPC_Exract_Libraries_from_ZipFile

REM #############################################################

EXIT
