@ECHO OFF
REM #############################################################
REM                CodeTyphon Studio 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################


REM ----------- Check for Bitness------------------
Set _BITNESS=64
IF %PROCESSOR_ARCHITECTURE% == x86 (
  IF NOT DEFINED PROCESSOR_ARCHITEW6432 Set _BITNESS=32
  )  
REM ----------------------------------------------- 
 
if %_Bitness% == 64 (
SET varzipdir="x86_64-win64"
) ELSE (
SET varzipdir="i386-win32"
)
REM ----------------------------------------------- 

ECHO.
ECHO ---------------------------------------------------------
ECHO               Extract CodeOcean Samples 
ECHO ---------------------------------------------------------

if EXIST ..\allzips\src\CodeOcean.7z (
mkdir ..\CodeOcean
..\binBase\%varzipdir%\7zr.exe x ..\allzips\src\CodeOcean.7z -o..\ -y
ECHO [INFO]: Extract CodeOcean Samples finish
) ELSE (
ECHO [ERROR]: CodeOcean Samples Zip File NOT EXIST ???
)

ECHO.

EXIT
