@ECHO OFF
REM #############################################################
REM                CodeTyphon Studio 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################

Set vOK32=0
Set vOK64=0

IF '%1' == '32' GOTO BUILDTOOL32
IF '%1' == '64' (
Set vOK32=1
GOTO BUILDTOOL64
)

GOTO BUILDTOOL64

REM @@@@@@@@@@@@@@@@@@@@@@@@ BUILDFILE @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
:BUILDFILE

ECHO.
ECHO [INFO]: ------------- Build%VBITS% %VFILE% -----------------------
ECHO.

if EXIST ..\Settings\CT_Use_QT4.ctsw (
 START /B /WAIT ..\typhon\bin%VBITS%\typhonbuild.exe --build-all --ws=qt ..\typhon\tools\%VFILE%\%VFILE%.lpi
 GOTO ENDBUILDSUB
)

if EXIST ..\Settings\CT_Use_QT5.ctsw (
 START /B /WAIT ..\typhon\bin%VBITS%\typhonbuild.exe --build-all --ws=qt5 ..\typhon\tools\%VFILE%\%VFILE%.lpi
 GOTO ENDBUILDSUB
)

if EXIST ..\Settings\CT_Use_GTK2.ctsw (
 START /B /WAIT ..\typhon\bin%VBITS%\typhonbuild.exe --build-all --ws=gtk2 ..\typhon\tools\%VFILE%\%VFILE%.lpi
 GOTO ENDBUILDSUB
)

if EXIST ..\Settings\CT_Use_GTK3.ctsw (
 START /B /WAIT ..\typhon\bin%VBITS%\typhonbuild.exe --build-all --ws=gtk3 ..\typhon\tools\%VFILE%\%VFILE%.lpi
 GOTO ENDBUILDSUB
)

if EXIST ..\Settings\CT_Use_CustomDrawn.ctsw (
 START /B /WAIT ..\typhon\bin%VBITS%\typhonbuild.exe --build-all --ws=customdrawn ..\typhon\tools\%VFILE%\%VFILE%.lpi
 GOTO ENDBUILDSUB
)

if EXIST ..\Settings\CT_Use_fpGUI.ctsw (
 START /B /WAIT ..\typhon\bin%VBITS%\typhonbuild.exe --build-all --ws=fpgui ..\typhon\tools\%VFILE%\%VFILE%.lpi
 GOTO ENDBUILDSUB
)

START /B /WAIT ..\typhon\bin%VBITS%\typhonbuild.exe --build-all ..\typhon\tools\%VFILE%\%VFILE%.lpi

REM ====== ENDBUILDSUB ======
:ENDBUILDSUB

if EXIST ..\typhon\tools\%VFILE%\%VFILE%.exe (
ECHO.
move /Y ..\typhon\tools\%VFILE%\%VFILE%.exe ..\typhon\bin%VBITS%\
ECHO.
) else (
ECHO.
ECHO. ???????????????????????????????????????????????????
ECHO [ERROR]: Problem %VFILE%.exe %VBITS% NOT Build 
ECHO. ??????????????????????????????????????????????????
ECHO.
)

if EXIST ..\typhon\tools\%VFILE%\lib (
 del /f/s/q ..\typhon\tools\%VFILE%\lib\ > nul
 rmdir /s/q ..\typhon\tools\%VFILE%\lib\
)

GOTO TASK%vLOOPNUM%


REM @@@@@@@@@@@@@@@@@@@@@@@@ BUILDTOOL64 @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
:BUILDTOOL64
Set vOK64=1
Set VBITS=64
Set VCPUOS=x86_64-win64
SET path=C:\codetyphon\fpc\fpc64\bin\x86_64-win64;%path%

if NOT EXIST ..\typhon\bin64\typhonbuild.exe (
GOTO TASKEND
)

ECHO.
ECHO -----------------------------------------------
ECHO              Build Typhon%VBITS% Tools
ECHO -----------------------------------------------

if EXIST ..\typhon\tools\lazres.exe (
move /Y ..\typhon\tools\lazres.exe ..\typhon\bin64\
)
if EXIST ..\typhon\tools\lrstolfm.exe (
move /Y ..\typhon\tools\lrstolfm.exe ..\typhon\bin64\
)

Set vLOOPNUM=0
GOTO TASK%vLOOPNUM%

REM @@@@@@@@@@@@@@@@@@@@@@@@ BUILDTOOL32 @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
:BUILDTOOL32
Set vOK32=1
Set VBITS=32
Set VCPUOS=i386-win32
SET path=C:\codetyphon\fpc\fpc32\bin\i386-win32;%path%

if NOT EXIST ..\typhon\bin32\typhonbuild.exe (
GOTO TASKEND
)

ECHO.
ECHO -----------------------------------------------
ECHO              Build Typhon%VBITS% Tools
ECHO -----------------------------------------------

REM -------------- Move 32bits Tools Executables ----------------

if EXIST ..\typhon\tools\lazres.exe (
move /Y ..\typhon\tools\lazres.exe ..\typhon\bin32\
) 
if EXIST ..\typhon\tools\lrstolfm.exe (
move /Y ..\typhon\tools\lrstolfm.exe ..\typhon\bin32\
)

Set vLOOPNUM=0
GOTO TASK%vLOOPNUM%

REM @@@@@@@@@@@@@@@@@@@@@@@@ TASKS @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

:TASK0
Set VFILE=ctapimatrix
Set vLOOPNUM=1
GOTO BUILDFILE

:TASK1
Set VFILE=ctchmbuilder
Set vLOOPNUM=2
GOTO BUILDFILE

:TASK2
Set VFILE=ctchmviewer
Set vLOOPNUM=3
GOTO BUILDFILE

:TASK3
Set VFILE=ctdatadesktop
Set vLOOPNUM=4
GOTO BUILDFILE

:TASK4
Set VFILE=ctdiagramins
Set vLOOPNUM=5
GOTO BUILDFILE

:TASK5
Set VFILE=cthexeditor
Set vLOOPNUM=6
GOTO BUILDFILE

:TASK6
Set VFILE=ctimageeditor
Set vLOOPNUM=7
GOTO BUILDFILE

:TASK7
Set VFILE=ctjsonviewer
Set vLOOPNUM=8
GOTO BUILDFILE

:TASK8
Set VFILE=ctpobuilder
Set vLOOPNUM=9
GOTO BUILDFILE

:TASK9
Set VFILE=ctresbuilder
Set vLOOPNUM=10
GOTO BUILDFILE

:TASK10
Set VFILE=ctunieditor
Set vLOOPNUM=END
GOTO BUILDFILE


REM ----------------------------------

:TASKEND
IF '%1' == '32' (
GOTO DOEXIT
) ELSE (
IF '%vOK32%' == '0' GOTO BUILDTOOL32
)

REM @@@@@@@@@@@@@@@@@@@@@@@@ DOEXIT @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
:DOEXIT

ECHO.
ECHO [INFO]: ------- Clean tools Directory ---------
del /F /Q /S ..\typhon\tools\*.o
del /F /Q /S ..\typhon\tools\*.ppu
del /F /Q /S ..\typhon\tools\*.compiled
del /F /Q /S ..\typhon\tools\*.exe

EXIT

